
#include <iostream>
#include <cmath>
#include <algorithm>
#include <stdio.h>
#include <cstring>
#include <string>
#include <cstdlib>
#include <vector>
#include <bitset>
#include <map>
#include <chrono>
#include <functional>
#include <unordered_set>
#include <unordered_map>
#include <numeric>
#include <queue>
#include <ctime>
#include <stack>
#include <set>
#include <list>
#include <deque>
#include <iomanip>
#include <sstream>
#include <fstream>
#include "testlib.h"
#include <stdarg.h>
#include <utility>

using namespace std;

int main(int argc, char* argv[]) {
    registerTestlibCmd(argc, argv);
    int n = ouf.readInt(-1, 250);
    int n2 = ans.readInt(-1, 250);
    if (n == -1) {
        if (n2 == -1) quitf(_ok, "No solution exist.");
        quitf(_wa, "Participant did not found the correct solution.");
    }
    int m = ouf.readInt(0, 250); ouf.readEoln();
    vector<string> s(n);
    int cw = 0, cb = 0;
    int nw = inf.readInt(), nb = inf.readInt();
    for (int i = 0; i < n; i++)
    {
        
        s[i] = ouf.readString("[.WB]*");
        cw += count(s[i].begin(), s[i].end(), 'W');
        cb += count(s[i].begin(), s[i].end(), 'B');
        if (s[i].size() != m)
            quitf(_pe, "Wrong length of a row, should be %d", m);
    }
    if(cw != nw || cb != nb)
        quitf(_wa, "Figure does not contain required number of white and black cells.");
    vector<vector<bool> > used(n, vector< bool > (m));
    vector<pair<int,int> > d{ {-1, 0}, {+1, 0}, {0, -1}, {0, +1} };
    auto ok = [&](int x, int y) {
        return 0 <= x && x < n && 0 <= y && y < m && s[x][y] != '.';
    };
    bool cmp = 0;
    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++)
            if (s[i][j] != '.' && !used[i][j]) {
                if(cmp == 1) quitf(_wa, "Figure is not connected");
                cmp = 1;
                queue<pair<int, int> > q;
                q.push(make_pair(i, j));
                used[i][j] = 1;
                while (q.size()) {
                    auto [u, v] = q.front();
                    q.pop();
                    for (auto [dx, dy] : d) {
                        int nx = u + dx, ny = v + dy;
                        if (!ok(nx, ny))continue;
                        if(s[nx][ny] == s[u][v])         
                            quitf(_wa, "Figure has to adjacent cells of the same colour.");
                        if (used[nx][ny]) continue;
                        q.push(make_pair(nx, ny));
                        used[nx][ny] = 1;
                    }
                }
            }

    quitf(_ok, "Participant found the correct solution.");
    
}
