#include <iostream>
#include <cmath>
#include <algorithm>
#include <stdio.h>
#include <cstring>
#include <string>
#include <cstdlib>
#include <vector>
#include <bitset>
#include <map>
#include <functional>
#include <unordered_set>
#include <unordered_map>
#include <numeric>
#include <queue>
#include <ctime>
#include <stack>
#include <set>
#include <list>
#include <deque>
#include <iomanip>
#include <sstream>
#include <fstream>
#include <stdarg.h>
#include <utility>
#include "testlib.h"

using namespace std;
int w, b;
int readAns(InStream& stream){//returns 1 if solution is found and 0 otherwise.
    int n = stream.readInt(-1, 250, "n");
    if(n == -1) return 0;
    if (n == 0) 
        stream.quitf(_pe, "got 0");
    int m = stream.readInt(1, 250, "m");
    stream.readEoln();
    vector<string> s(n);
    int cw = 0, cb = 0;
    for (int i = 0; i < n; i++){
        s[i] = stream.readString("[.WB]*", "s");
        cw += count(s[i].begin(), s[i].end(), 'W');
        cb += count(s[i].begin(), s[i].end(), 'B');
        if (s[i].size() != m)
            stream.quitf(_pe, "Wrong length of a row, should be %d", m);
    }
    if(cw != w || cb != b)
        stream.quitf(_wa, "Figure does not contain required number of white and black cells.");
    vector<vector<bool> > used(n, vector< bool > (m));
    vector<pair<int,int> > d{ {-1, 0}, {+1, 0}, {0, -1}, {0, +1} };
    auto ok = [&](int x, int y) {
        return 0 <= x && x < n && 0 <= y && y < m && s[x][y] != '.';
    };
    bool cmp = 0;
    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++)
            if (s[i][j] != '.' && !used[i][j]) {
                if(cmp == 1) stream.quitf(_wa, "Figure is not connected");
                cmp = 1;
                queue<pair<int, int> > q;
                q.push(make_pair(i, j));
                used[i][j] = 1;
                while (q.size()) {
                    auto [u, v] = q.front();
                    q.pop();
                    for (auto [dx, dy] : d) {
                        int nx = u + dx, ny = v + dy;
                        if (!ok(nx, ny))continue;
                        if(s[nx][ny] == s[u][v]) stream.quitf(_wa, "Figure has two adjacent cells of the same colour.");
                        if (used[nx][ny]) continue;
                        q.push(make_pair(nx, ny));
                        used[nx][ny] = 1;
                    }
                }
            }
    return 1;
}
int main(int argc, char * argv[]) {
    registerTestlibCmd(argc, argv);
    w = inf.readInt();
    b = inf.readInt();
    int jans = readAns(ans);
    int pans = readAns(ouf);
    if(pans != jans) quitf(jans ? _wa : _fail, "Participant ans is %d, juri ans is %d", pans, jans);
    else quitf(_ok, "Participant found correct figure, or correct figure does not exist.");
}