#include "testlib.h"
#include <string>

using namespace std;

#define rng(x) for(int _ = 0; _ < (x); _++)
#define rngi(i, x) for(int i = 0; i < (x); i++)
#define rngsi(s, i, x) for(int i = (s); i <(x); i++)
#define vi vector<int>


const int mxn = 50'000;
const int mxl = 20;

int mxa = (1 << mxl) - 1;
int a[mxn], us[mxn];
vi g[mxn];
int cc = 0;
void dfs(int v){
    cc++;
    us[v] = 1;
    for(int u : g[v]) if(!us[u]) dfs(u);
}
void check_power2(int z){
    while(z % 2 == 0) z/=2;
    ensuref(z == 1, "Number must be a power of two.");
}
int main(int argc, char* argv[]) {
    registerValidation(argc, argv);
    int n = inf.readInt(2, mxn, "n"); inf.readSpace(); int gr = inf.readInt(0, 7, "gr"); inf.readEoln();
    ensure(gr == stoi(validator.group()));
    for(int i = 0; i  + 1 < n; i++){
        int u = inf.readInt(1, n, "u");
        inf.readSpace();
        int v = inf.readInt(1, n, "v");
        g[u - 1].push_back(v - 1);
        g[v - 1].push_back(u - 1);
        inf.readEoln();
    }
    
    for(int i = 0; i < n; i++){
        a[i] = inf.readInt(0, mxa, "a_i");
        if(gr == 6) check_power2(a[i]);
        if(i != n - 1) inf.readSpace();
        else inf.readEoln();
    }
    dfs(0);
    ensuref(cc == n, "Graph should be connected");

    int q = inf.readInt(1, mxn, "q"); inf.readEoln();

    if(gr == 1)ensuref(max(n, q) <= 15, "In group 1 n,q <= 15");
    if(gr == 2)ensuref(max(n, q) <= 500, "In group 2 n,q <= 500");
    if(gr == 3)ensuref(max(n, q) <= 2000, "In group 3 n,q <= 2000");

    rng(q){
        int tp = inf.readInt(1, 2, "tp"); inf.readSpace();
        if(tp == 1){
            ensuref(gr != 5, "This group should not have change queries");
            int x = inf.readInt(1, n, "x");
            inf.readSpace();
            int y = inf.readInt(0, mxa, "y");
            if(gr == 6) check_power2(y);
            a[x - 1] = y;
        }
        else{
            int x = inf.readInt(1, n, "x");
            
            ensuref((gr != 4 || x == 1), "In this gruop queries should be only from root.");
            inf.readSpace();
            int k = inf.readInt(1, 1000'000'000, "k");
        }
        inf.readEoln();
    }
    inf.readEof();
}